import { __values, __spread } from 'tslib';
import { Directive, forwardRef, Renderer2, ElementRef, Input, HostListener, NgModule } from '@angular/core';
import { NG_VALUE_ACCESSOR, NG_ASYNC_VALIDATORS, FormsModule, ReactiveFormsModule } from '@angular/forms';
import { of, forkJoin, fromEventPattern, ReplaySubject } from 'rxjs';
import { map, take, shareReplay, first } from 'rxjs/operators';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var FileInputAccessor = /** @class */ (function () {
    function FileInputAccessor(_renderer, _elementRef) {
        this._renderer = _renderer;
        this._elementRef = _elementRef;
        this.onChange = (/**
         * @param {?} _
         * @return {?}
         */
        function (_) { });
        this.onTouched = (/**
         * @return {?}
         */
        function () { });
        this.validator = this.generateAsyncValidator();
    }
    Object.defineProperty(FileInputAccessor.prototype, "allowedExt", {
        get: /**
         * @return {?}
         */
        function () {
            return this._allowedExt;
        },
        set: /**
         * @param {?} value
         * @return {?}
         */
        function (value) {
            if (typeof value === 'string') {
                value = value + '$';
            }
            if (value instanceof Array) {
                value = value.join('|') + '$';
            }
            this._allowedExt = value;
        },
        enumerable: true,
        configurable: true
    });
    /**
     * @param {?} value
     * @return {?}
     */
    FileInputAccessor.prototype.writeValue = /**
     * @param {?} value
     * @return {?}
     */
    function (value) {
        this._renderer.setProperty(this._elementRef.nativeElement, 'value', null);
    };
    /**
     * @param {?} fn
     * @return {?}
     */
    FileInputAccessor.prototype.registerOnChange = /**
     * @param {?} fn
     * @return {?}
     */
    function (fn) {
        this.onChange = this.onChangeGenerator(fn);
    };
    /**
     * @param {?} fn
     * @return {?}
     */
    FileInputAccessor.prototype.registerOnTouched = /**
     * @param {?} fn
     * @return {?}
     */
    function (fn) { };
    /**
     * @param {?} isDisabled
     * @return {?}
     */
    FileInputAccessor.prototype.setDisabledState = /**
     * @param {?} isDisabled
     * @return {?}
     */
    function (isDisabled) {
        this._renderer.setProperty(this._elementRef.nativeElement, 'disabled', isDisabled);
    };
    /**
     * @param {?} c
     * @return {?}
     */
    FileInputAccessor.prototype.validate = /**
     * @param {?} c
     * @return {?}
     */
    function (c) {
        return this.validator(c);
    };
    /**
     * Generator method that I used to move the code for the AsyncValidator down here so it didn't
     * get in my way, way up there ^.
     */
    /**
     * Generator method that I used to move the code for the AsyncValidator down here so it didn't
     * get in my way, way up there ^.
     * @private
     * @return {?}
     */
    FileInputAccessor.prototype.generateAsyncValidator = /**
     * Generator method that I used to move the code for the AsyncValidator down here so it didn't
     * get in my way, way up there ^.
     * @private
     * @return {?}
     */
    function () {
        var _this = this;
        return (/**
         * @param {?} c
         * @return {?}
         */
        function (c) {
            var e_1, _a;
            if (!c.value || !c.value.length || c.disabled)
                return of({});
            /** @type {?} */
            var errors = {};
            /** @type {?} */
            var loaders = [];
            var _loop_1 = function (f) {
                if (_this.size && _this.size < f.size) {
                    f.errors.fileSize = true;
                    errors.fileSize = true;
                }
                if (f.isImg && (_this.maxWidth || _this.maxHeight)) {
                    loaders.push(f.imgLoadReplay
                        .pipe(take(1), map((/**
                     * @param {?} e
                     * @return {?}
                     */
                    function (e) {
                        /** @type {?} */
                        var minWidthError = _this.minWidth && f.imgWidth < _this.minWidth;
                        /** @type {?} */
                        var minHeightError = _this.minHeight && f.imgHeight < _this.minHeight;
                        /** @type {?} */
                        var maxWidthError = _this.maxWidth && f.imgWidth > _this.maxWidth;
                        /** @type {?} */
                        var maxHeightError = _this.maxHeight && f.imgHeight > _this.maxHeight;
                        if (minWidthError) {
                            f.errors.minWidth = true;
                            errors.minWidth = true;
                        }
                        if (minHeightError) {
                            f.errors.minHeight = true;
                            errors.minHeight = true;
                        }
                        if (maxWidthError) {
                            f.errors.maxWidth = true;
                            errors.maxWidth = true;
                        }
                        if (maxHeightError) {
                            f.errors.maxHeight = true;
                            errors.maxHeight = true;
                        }
                        /** will be @deprecated **/
                        if (minWidthError || maxWidthError) {
                            f.errors.imageWidth = true;
                            errors.imageWidth = true;
                        }
                        /** will be @deprecated **/
                        if (minHeightError || maxHeightError) {
                            f.errors.imageHeight = true;
                            errors.imageHeight = true;
                        }
                        return e;
                    }))));
                }
                if (!_this.allowedExt && !_this.allowedTypes)
                    return "continue";
                /** @type {?} */
                var extP = _this.generateRegExp(_this.allowedExt);
                /** @type {?} */
                var typeP = _this.generateRegExp(_this.allowedTypes);
                if (extP && !extP.test(f.name)) {
                    f.errors.fileExt = true;
                    errors.fileExt = true;
                }
                if (typeP && !typeP.test(f.type)) {
                    f.errors.fileType = true;
                    errors.fileType = true;
                }
            };
            try {
                for (var _b = __values(c.value), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var f = _c.value;
                    _loop_1(f);
                }
            }
            catch (e_1_1) { e_1 = { error: e_1_1 }; }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
                }
                finally { if (e_1) throw e_1.error; }
            }
            if (loaders.length) {
                return forkJoin.apply(void 0, __spread(loaders)).pipe(map((/**
                 * @return {?}
                 */
                function () { return errors; })));
            }
            return of(errors);
        });
    };
    /**
     * Generator method that returns an onChange handler
     */
    /**
     * Generator method that returns an onChange handler
     * @private
     * @param {?} fn
     * @return {?}
     */
    FileInputAccessor.prototype.onChangeGenerator = /**
     * Generator method that returns an onChange handler
     * @private
     * @param {?} fn
     * @return {?}
     */
    function (fn) {
        var _this = this;
        return (/**
         * @param {?} files
         * @return {?}
         */
        function (files) {
            var e_2, _a;
            /** @type {?} */
            var fileArr = [];
            try {
                for (var files_1 = __values(files), files_1_1 = files_1.next(); !files_1_1.done; files_1_1 = files_1.next()) {
                    var f = files_1_1.value;
                    if (_this.withMeta && FileReader) {
                        /** @type {?} */
                        var fr = new FileReader();
                        _this.generateFileMeta(f, fr);
                    }
                    f.errors = {};
                    fileArr.push(f);
                }
            }
            catch (e_2_1) { e_2 = { error: e_2_1 }; }
            finally {
                try {
                    if (files_1_1 && !files_1_1.done && (_a = files_1.return)) _a.call(files_1);
                }
                finally { if (e_2) throw e_2.error; }
            }
            fn(fileArr);
        });
    };
    /**
     * @private
     * @param {?} pattern
     * @return {?}
     */
    FileInputAccessor.prototype.generateRegExp = /**
     * @private
     * @param {?} pattern
     * @return {?}
     */
    function (pattern) {
        if (!pattern)
            return null;
        if (pattern instanceof RegExp) {
            return new RegExp(pattern);
        }
        else if (typeof pattern === 'string') {
            return new RegExp(pattern, 'ig');
        }
        else if (pattern instanceof Array) {
            return new RegExp("(" + pattern.join('|') + ")", 'ig');
        }
        return null;
    };
    /**
     * The ICustomFile has a ReplaySubject property for text / image files that will emit
     * once the file has been loaded. Might get removed later since I haven't found a use for it yet.
     */
    /**
     * The ICustomFile has a ReplaySubject property for text / image files that will emit
     * once the file has been loaded. Might get removed later since I haven't found a use for it yet.
     * @private
     * @param {?} f
     * @param {?} fr
     * @return {?}
     */
    FileInputAccessor.prototype.generateFileMeta = /**
     * The ICustomFile has a ReplaySubject property for text / image files that will emit
     * once the file has been loaded. Might get removed later since I haven't found a use for it yet.
     * @private
     * @param {?} f
     * @param {?} fr
     * @return {?}
     */
    function (f, fr) {
        if (f.type.match(/text.*/)) {
            f.textLoadReplay = this.setText(f, fr);
        }
        else if (f.type.match(/image.*/)) {
            f.imgLoadReplay = this.setImage(f, fr);
        }
    };
    /**
     * @private
     * @param {?} f
     * @param {?} fr
     * @return {?}
     */
    FileInputAccessor.prototype.setImage = /**
     * @private
     * @param {?} f
     * @param {?} fr
     * @return {?}
     */
    function (f, fr) {
        f.isImg = true;
        /** @type {?} */
        var img = new Image();
        /** @type {?} */
        var imgLoadObs = fromEventPattern(((/**
         * @param {?} handler
         * @return {?}
         */
        function (handler) { return img.addEventListener('load', handler); })), ((/**
         * @param {?} handler
         * @return {?}
         */
        function (handler) { return img.removeEventListener('load', handler); }))).pipe(take(1), shareReplay());
        /** @type {?} */
        var frLoadObs = fromEventPattern(((/**
         * @param {?} handler
         * @return {?}
         */
        function (handler) { return fr.addEventListener('load', handler); })), ((/**
         * @param {?} handler
         * @return {?}
         */
        function (handler) { return fr.removeEventListener('load', handler); }))).pipe(take(1), shareReplay());
        /** @type {?} */
        var onloadReplay = new ReplaySubject(1);
        forkJoin(imgLoadObs, frLoadObs).pipe(first()).subscribe(onloadReplay);
        imgLoadObs.pipe(first()).subscribe((/**
         * @return {?}
         */
        function () {
            f.imgHeight = img.height;
            f.imgWidth = img.width;
        }));
        frLoadObs.pipe(first()).subscribe((/**
         * @return {?}
         */
        function () {
            f.imgSrc = fr.result + '';
            img.src = fr.result + '';
        }));
        fr.readAsDataURL(f);
        return onloadReplay;
    };
    /**
     * @private
     * @param {?} f
     * @param {?} fr
     * @return {?}
     */
    FileInputAccessor.prototype.setText = /**
     * @private
     * @param {?} f
     * @param {?} fr
     * @return {?}
     */
    function (f, fr) {
        /** @type {?} */
        var frLoadObs = fromEventPattern(((/**
         * @param {?} handler
         * @return {?}
         */
        function (handler) { return fr.addEventListener('load', handler); })), ((/**
         * @param {?} handler
         * @return {?}
         */
        function (handler) { return fr.removeEventListener('load', handler); }))).pipe(take(1), shareReplay());
        /** @type {?} */
        var onloadReplay = new ReplaySubject(1);
        frLoadObs.subscribe(onloadReplay);
        frLoadObs.pipe(first()).subscribe((/**
         * @return {?}
         */
        function () {
            f.textContent = fr.result + '';
        }));
        fr.readAsText(f);
        return onloadReplay;
    };
    FileInputAccessor.decorators = [
        { type: Directive, args: [{
                    selector: 'input[type=file][formControl],input[type=file][formControlName],input[type=file][ngModel]',
                    providers: [
                        {
                            provide: NG_VALUE_ACCESSOR,
                            useExisting: forwardRef((/**
                             * @return {?}
                             */
                            function () { return FileInputAccessor; })),
                            multi: true
                        },
                        {
                            provide: NG_ASYNC_VALIDATORS,
                            useExisting: forwardRef((/**
                             * @return {?}
                             */
                            function () { return FileInputAccessor; })),
                            multi: true
                        }
                    ]
                },] }
    ];
    /** @nocollapse */
    FileInputAccessor.ctorParameters = function () { return [
        { type: Renderer2 },
        { type: ElementRef }
    ]; };
    FileInputAccessor.propDecorators = {
        allowedTypes: [{ type: Input }],
        size: [{ type: Input }],
        withMeta: [{ type: Input }],
        maxHeight: [{ type: Input }],
        maxWidth: [{ type: Input }],
        minHeight: [{ type: Input }],
        minWidth: [{ type: Input }],
        allowedExt: [{ type: Input }],
        onChange: [{ type: HostListener, args: ['change', ['$event.target.files'],] }],
        onTouched: [{ type: HostListener, args: ['blur',] }]
    };
    return FileInputAccessor;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var FileInputAccessorModule = /** @class */ (function () {
    function FileInputAccessorModule() {
    }
    FileInputAccessorModule.decorators = [
        { type: NgModule, args: [{
                    declarations: [FileInputAccessor],
                    imports: [
                        FormsModule,
                        ReactiveFormsModule
                    ],
                    exports: [
                        FileInputAccessor,
                        FormsModule,
                        ReactiveFormsModule
                    ]
                },] }
    ];
    return FileInputAccessorModule;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { FileInputAccessor, FileInputAccessorModule };
//# sourceMappingURL=file-input-accessor.js.map
